!!ARBfp1.0
OPTION NV_fragment_program2;

# Copyright (c) 2005  Institute for Visualization and Interactive
# Systems, University of Stuttgart, Germany
#
# This source code is distributed as part of the single-pass volume
# rendering project. Details about this project can be found on the
# project web page at http://www.vis.uni-stuttgart.de/eng/research/
# fields/current/spvolren. This file may be distributed, modified,
# and used free of charge as long as this copyright notice is
# included in its original form. Commercial use is strictly
# prohibited.
#
# Filename: volume_sm3.fp

#! VOLUME = 0
#! MEASURE = 2
#! TRANSFERFUNCTION = 1
# BACKGROUND = 2
#! VISIBILITY = 4

# r = step
# g = gradient scale
# b = gradient offset
# a = z-value of background plane
PARAM params = program.local[0];

# r = texture coordinate scale
# g = number of iterations
# b = isovalue of isosurface
PARAM params2 = program.local[1];
PARAM center = program.local[2];
PARAM texMax = program.local[3];

PARAM scaleFactors = program.local[5];

PARAM clipValue = program.local[7];

TEMP geomPos;
TEMP texblen;
TEMP scalar;
TEMP temp;
TEMP pos;
TEMP src;
TEMP dst;
TEMP dir;
TEMP tex;

TEMP measureColor;
MOV measureColor, 0;
MOV measureColor.x, 1;
MOV measureColor.y, 1;
MOV measureColor.z, .4;
MOV measureColor.a, .5;

# Compute the ray's starting point
MOV geomPos, fragment.texcoord[0];
MUL pos, geomPos, scaleFactors;
MOV pos.a, 0.0;

# Initialize scalar value
# RGB = gradient, alpha = scalar value
TXL scalar, pos, texture[0], 3D;
MOV scalar.g, scalar.a;
MOV scalar.a, 0.0;
MOV scalar.b, 0.0;

# Initialize destination color
MOV dst, 0.0;

# Move one step forward
#MAD pos, dir, params.r, pos;

# Lookup new scalar value
TXL tex, pos, texture[0], 3D;           # tex = texture3D[pos];
MOV scalar.r, tex.a;                    # scalar.r = tex.a;
		
			# Check visibility data
			TXL tex, pos, texture[4], 3D;
			SUBC tex.r, tex.r, clipValue.r; 
			IF GE.x;
			
				# Lookup color in pre-int texture
				TXL dst, scalar, texture[1], 2D;        # src = texture2D[scalar];
			
			
				# Perform blending
				MAD_SAT dst, src, texblen.r, dst;       # dst += src * texblen.r;
				
				# Measures
				TXL src, pos, texture[2], 3D;
				MUL_SAT src.r, src.r, 1024; # saturate to 1
				MAD dst, measureColor, src.r, dst;
			ENDIF;			


# Measures
#TXL src, pos, texture[2], 3D;
#MUL_SAT src.r, src.r, 1024; # saturate to 1
#MAD dst, measureColor, src.r, dst;

# Increase contrast
MUL dst, dst, 1.75;
#MOV dst.a, 1.0;

# Look up the texel value
#TEX temp.rgb, temp, texture[2], 2D;
MOV temp, .4;
MOV temp.a, 1.0;

# Blend the background pixel
SUB texblen, 1.0, dst.a;
MAD dst, temp, texblen.x, dst;

# Write the output color
MOV result.color, dst;

#MOV result.color, geomPos;#fragment.texcoord[0];

END
	